/// Response class for IDs generated by IDGen.
class IDGenResponse {
  final String id;

  IDGenResponse({required this.id});

  factory IDGenResponse.fromJson(Map<String, dynamic> json) {
    return IDGenResponse(
      id: json['id'],
    );
  }
}

/// Response class for keypairs generated by IDGen.
class IDKeypairResponse implements IDGenResponse {
  @override
  final String id;
  final String privateID;

  IDKeypairResponse({required this.id, required this.privateID});

  factory IDKeypairResponse.fromJson(Map<String, dynamic> json) {
    return IDKeypairResponse(
      id: json['id'],
      privateID: json['privateID'],
    );
  }
}

/// Custom exception for IDGen, thrown when an error occurs when generating an ID.
class IDGenException implements Exception {
  final String message;

  IDGenException(this.message);

  @override
  String toString() {
    return message;
  }
}
